;
; fastload.asm - Fastload for 1541/1570/1571/1581
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

fastloadinit 	.proc
                #sta_cfg_open
                lda setup_atribut_exp
                #sta_cfg_16
                and #CMOS_TURBO
                bne *+3
                rts

		#phx_a
                sty pom4
                
                jsr listen
		ldx #5
smr		lda mr,x
		jsr $eddd
		dex
		bpl smr
                jsr $edfe
                
                lda pom4
                jsr $ed09
                lda #$6f
                jsr $edc7
                jsr $ee13
                tax
                jsr $ee13
                tay
                jsr $edef

		lda #2
                cpx #$a0
                bne qq
                cpy #$ea
                beq jo
qq		lda #5
                cpx #$24
                bne nemjo
                cpy #$af
                bne nemjo

jo		tax
		ldy #3
lle		lda cucc,x
		sta pom1-1,y
                dex
                dey
                bne lle
sloop		jsr listen

		ldx #2
smw		lda mw,x
		jsr $eddd
		dex
		bpl smw
		tya
		jsr $eddd
                lda #5
		jsr $eddd
		lda #35
                tax
		jsr $eddd

slp		lda (pom1),y
		jsr $eddd
		iny
                dex
		bne slp
		jsr $edfe

		cpy pom3
		bcc sloop
		jsr listen

		ldy #17
sme		lda me,y
		jsr $eddd
		dey
		bpl sme
                lda $dd00
                and #3
                jsr $eddd
		jsr $edfe
                lda #$23
                sta $dd00
                sec
                ror next_sector
                ldx #0
                dex
                bne *-1

nemjo           #plx_a
                rts

listen		lda pom4
		jsr $ed0c
		lda #$6f
		jmp $edb9
;---------------------------------------
cucc		.word drive154171
		.byte driveend-drive154171
                .word drive1581
		.byte driveend2-drive1581
                
mw		.text "W-M"
mr		.text $02,$ff,$fc,"R-M"

me		.byte $00,$08,$02,$0a
                .byte $04,$0c,$06,$0e
                .byte $01,$09,$03,$0b
                .byte $05,$0d,$07,$0f
		.text "3U"
;---------------------------------------
		.pend

drive154171	.proc

		.logical $500
                
p1		= $06
p2		= $07
p3		= $0a
p4		= $0b

start	        sei
		lda #$08
		sta $1800
		lda $19
		sta $09
		lda $18
		sta $08

ss		lda $1800
                lsr
                bcs ss

                lda $31
                cmp #$04
                bne read

loop		lda $1801
                pha
                and #$df
                sta $1801
;-----------------------------------
tk		ldy #4
                .byte $af,$01,$04
                sta $09;$81
                lda $400
                sta $08
                bne hto
                tya
                clc
                sbc $09;$81
                inx
                stx $30
                beq ntnk
                dec $31
ntnk            tay
hto		
 		lda $1800
                and #$60
                sta p3
                ora #$0d
                sta p2
                jsr $e9a5	;1800 or 2
                eor #$0d
                sta $1800
                jsr $fef3	;wait
sndlp		.byte $b3,$30;lda ($30),y
;		tax
                lsr
                lsr
                lsr
                lsr
                sta p1
                lda #$0f
                .byte $cb,$00;sbx #0
                lda $202,x
                ldx p3
                stx $1800
                cpx $1800
                beq *-3
                sta $1800
                asl
                and #$0f
                nop
                sta $1800
                ldx p1
                lda $202,x
                sta $1800
                asl
                and #$0f
                iny
                sta $1800
		bne sndlp
                nop
                ldx p2
		stx $1800
nn              cpx $1800
                bcc vv
                bne nn

		lda #2
                sta tk+1
;-----------------------------------
                lda $08
		beq vv
		pla
                sta $1801
                
read		ldy #20
lp2		lda #$80
		sta $01
		cli
		lda $01
		bmi *-2
		sei
		cmp #$01
		beq loop
		dey
                bne lp2
                lda #$23
                sta $26c
                rts

vv 		jsr ee
		pla
                sta $1801
                rts

ee		jsr xj
                jsr xj
                jsr $e9ae	;1800 or 8
xj              ldx #20
                dex
                bne *-1
                jmp $e9b7	;1800 and ~8

		.here
                
                .pend
driveend


drive1581	.proc

		.logical $500
                
p1		= $0b
p2		= $0c
p3		= $0d
p4		= $0e

start	        sei
		lda #$08
		sta $4001

ss		lda $4001
                lsr
                bcs ss

                lda $49
                cmp #$08
                beq loop
                asl
                tax
                lda $b-6,x
                sta $15
                lda $c-6,x
                sta $16
                gcc read

loop		
;-----------------------------------
tk		ldy #4
                .byte $af,$01,$08
                sta $16;$81
                lda $800
                sta $15
                bne hto
                tya
                clc
                sbc $16;$81
                inx
                stx $48
                beq ntnk
                dec $49
ntnk            tay
hto		
 		lda $4001
                and #$60
                sta p3
                ora #$0d
                sta p2
                ora #2
                sta $4001
                eor #$0d
                sta $4001
                ldx #14
                dex
                bne *-1
sndlp		lda ($48),y
		tax
                lsr
                lsr
                lsr
                lsr
                sta p1
                txa
                and #$0f
                tax
                lda $202,x
                ldx p3
                jsr e3ae
                stx $4001
                nop
                nop
                cpx $4001
                beq *-3
                pha
                pla
                nop
                sta $4001
                asl
                and #$0f
                pha
                pla
                ldx p1
                ora #$10
                sta $4001
                lda $202,x
                pha
                pla
                pha
                pla
                sta $4001
                asl
                and #$0f
                ora #$10
                cmp (0,x)
                nop
                nop
                iny
                sta $4001
		bne sndlp
                lda @wp2
                jsr e3b7
		sta $4001
nn              bit $4001
                cmp $4001
                bcc vv
                bne nn

		lda #2
                sta tk+1
;-----------------------------------
                lda $15
		beq vv
                
read		ldy #20
lp2		lda #$80
		sta $07
		cli
		lda $07
		bmi *-2
		sei
		beq loop
		dey
                bne lp2
                lda #$23
                sta $2ab
                rts

vv 		jsr xj
                jsr xj
                lda $4001
                ora #$08
                sta $4001
xj              ldx #20*2+2
                dex
                bne *-1
                lda $4001
                and #$f7
                sta $4001
                rts

e3ae		jsr e3b7
e3b7            rts

		.if *>$600
                .error
                .fi

		.here
                
                .pend
driveend2	

